local addonName, addonTable = ...;
local L=addonTable.locale
local gsub = _G.string.gsub
local match = _G.string.match
local _, _, _, tocversion = GetBuildInfo()
--------------
local QuickChatfun = addonTable.QuickChatfun
local FasongYCqingqiu=addonTable.FasongYCqingqiu
--------
local JJM = L["CHAT_QUKBUTNAME"]
local function jingjianTXT(text)
	if PIGA["Chat"]["jingjian"] then
		local text=text:gsub(" (|Hplayer:.+)", "%1")
		local text=text:gsub("|h%["..SPELL_TARGET_TYPE11_DESC.."%]|h", "|h%["..JJM[3].."%]|h")--队伍
		local text=text:gsub("|h%["..GUILD.."%]|h", "|h%["..JJM[4].."%]|h")--公會
		local text=text:gsub("|h%["..CHAT_MSG_RAID.."%]|h", "|h%["..JJM[5].."%]|h")--团队
		local text=text:gsub("|h%["..CHAT_MSG_RAID_WARNING.."%]|h", "|h%["..JJM[6].."%]|h")--團隊通告
		local text=text:gsub("|h%["..CHAT_MSG_BATTLEGROUND.."%]|h", "|h%["..JJM[7].."%]|h")--戰場
		local text=text:gsub("|h%["..INSTANCE_CHAT.."%]|h", "|h%["..JJM[7].."%]|h")--副本
		--xuhao
		local text=text:gsub("|h%[(%d+)%. "..GENERAL.."(.-)%]|h", "|h%[%1%."..JJM[8].."%]|h")--综合
		local text=text:gsub("|h%[(%d+)%. "..LOOK_FOR_GROUP.."%]|h", "|h%[%1%."..JJM[9].."%]|h")--寻求组队
		local text=text:gsub("|h%[(%d+)%. PIG%]|h", "|h%[%.PIG%]|h")
		local text=text:gsub("|h%[(%d+)%. 大脚世界频道%]|h", "|h%[%1%."..JJM[11].."%]|h")
		if GetLocale() == "zhCN" then
			local text=text:gsub("|h%["..INSTANCE_CHAT_LEADER.."%]|h", "|h%[导%]|h")--副本向导
			local text=text:gsub("|h%["..CHAT_MSG_RAID_LEADER.."%]|h", "|h%[领%]|h")--团队领袖
			local text=text:gsub("(|Hplayer:.-|h)说", "%[说%]%1")
			local text=text:gsub("(|Hplayer:.-|h)喊道", "%[喊%]%1")
			local text=text:gsub("|h%[队长%]|h", "|h%[长%]|h")--队长
			local text=text:gsub("|h%[小队%]|h", "|h%[队%]|h")--小队
			--xuhao
			local text=text:gsub("|h%[(%d+)%. "..TRADE.." %- 城市%]|h", "|h%[%1%.交%]|h")
			if tocversion>99999 then
				local text=text:gsub("|h%[(%d+)%. "..TRADE.." %(服务%) %- 城市%]|h", "|h%[%1%.服%]|h")
				local text=text:gsub("|h%[(%d+)%. 新手聊天%]|h", "|h%[%1%.新%]|h")
				return text
			end
			return text
		elseif GetLocale() == "zhTW" then
			local text=text:gsub("|h%["..INSTANCE_CHAT_LEADER.."%]|h", "|h%[導%]|h")--副本向导
			local text=text:gsub("|h%["..CHAT_MSG_RAID_LEADER.."%]|h", "|h%[領%]|h")--团队领袖
			local text=text:gsub("(|Hplayer:.-|h)說", "%[說%]%1")
			local text=text:gsub("(|Hplayer:.-|h)喊道", "%[喊%]%1")
			local text=text:gsub("|h%[隊長%]|h", "|h%[長%]|h")--队长
			local text=text:gsub("|h%[小隊%]|h", "|h%[隊%]|h")--小队
			--xuhao
			local text=text:gsub("|h%[(%d+)%. "..TRADE.." %- 城市%]|h", "|h%[%1%.交%]|h")
			if tocversion>99999 then
				local text=text:gsub("|h%[(%d+)%. "..TRADE.." %(服務%) %- 城市%]|h", "|h%[%1%.服%]|h")
				local text=text:gsub("|h%[(%d+)%. 新手聊天%]|h", "|h%[%1%.新%]|h")
				return text
			end
			return text
		end
	end
	return text
end
local ShowZbIcon="|T133122:13|t"
local function ShowZb(text)
	if PIGA["Chat"]["ShowZb"] then
		--if text:match("Hchannel") then
		--ChatFrame99:AddMessage(text:gsub("|", "||"));
		return text:gsub("(|Hplayer:(.-)|h%[.-%]|h)", "|Hgarrmission:%2|h"..ShowZbIcon.."|h%1")
	end
	return text
end
---
local biaoqingTXT={}--表情字符
for i=1,#QuickChatfun.biaoqing do
	local newvalueXxX = QuickChatfun.biaoqing[i][2]:gsub("%-", "%%-");
	table.insert(biaoqingTXT,newvalueXxX)
end
local function del_biaoqing(newText)--去除表情字符
	for i=1,#biaoqingTXT do
		newText = newText:gsub("|T"..biaoqingTXT[i]..":16|t", "");
	end
	return newText or ""
end
local function del_link(newText)--去除Link统一大小写
	local newText=newText:gsub("|cff%w%w%w%w%w%w|Hitem:.-|h%[","");
	local newText=newText:gsub("|cff%w%w%w%w%w%w|Henchant:.-|h%[","");
	local newText=newText:gsub("|cff%w%w%w%w%w%w|Htrade:.-|h%[","");
	local newText=newText:gsub("|cff%w%w%w%w%w%w|Hjournal:.-|h%[","");
	local newText=newText:gsub("|cff%w%w%w%w%w%w|Hachievement:.-|h%[","");
	local newText=newText:gsub("|cff%w%w%w%w%w%w|Hspell:.-|h%[","");
	local newText=newText:gsub("|cff%w%w%w%w%w%w|Hquest:.-|h%[","");
	--local newText=newText:gsub("|cff%w%w%w%w%w%w|Hquestie:(%d+):Player%-(%d+)%-(%w+)|h","");
	local newText=newText:gsub("|A.-%]|h|r","");
	local newText=newText:gsub("%]|h|r","");
	local newText=newText:gsub(" ","");
	local newText=newText:upper()--转换大小写
	return newText
end
local function del_biaodian(newText)		
	local duibiText=newText
	local duibiText=duibiText:gsub("%p","");
	local duibiText=duibiText:gsub("，","");
	local duibiText=duibiText:gsub("。","");
	local duibiText=duibiText:gsub("！","");
	local duibiText=duibiText:gsub("：","");
	local duibiText=duibiText:gsub("；","");
	local duibiText=duibiText:gsub("“","");
	local duibiText=duibiText:gsub("”","");
	local duibiText=duibiText:gsub("‘","");
	local duibiText=duibiText:gsub("’","");
	local duibiText=duibiText:gsub("~","");
	local duibiText=duibiText:gsub("%s","");
	return duibiText
end
local function BlackTxt(newText)
	local Chatlist_B = QuickChatfun["Blacklist"]
	if #Chatlist_B>0 then
		ChatFrame99.allCUNZAI_BLK = false;
		for x=1,#Chatlist_B do
			ChatFrame99.allCUNZAI_BLK_C = true;
			for xx=1,#Chatlist_B[x] do
				if not newText:match(Chatlist_B[x][xx]) then
					ChatFrame99.allCUNZAI_BLK_C = false
					break
				end
			end
			if ChatFrame99.allCUNZAI_BLK_C then
				ChatFrame99.allCUNZAI_BLK = true;
				break
			end
		end
		if ChatFrame99.allCUNZAI_BLK then
			return ChatFrame99.allCUNZAI_BLK
		end
	end
	return false
end
-----
local chongfufayanduibi={}--过滤重复发言临时
local keyzijiname = UnitName("player")
local function TiquKey(text,...)
	if PIGA["Chat"]["TiquKey"]["Open"] then
		if text:match("|Hchannel:channel:") then--是公共频道消息
			local fayanname=text:match("|Hplayer:(.-)%-.-|h%[.-%]|h")
			if fayanname==keyzijiname and PIGA["Chat"]["TiquKey"]["guolvzishen"] then
				--ChatFrame99:AddMessage(text,...);
			else
				--ChatFrame99:AddMessage(text);
				local newText = text:gsub("(|Hchannel:channel:.-|r%]|h)：","%1:")
				--ChatFrame99:AddMessage(newText:gsub("|","||"));
				local newText=newText:match("|Hchannel:channel:.-|r%]|h:(.+)")
				local newText = del_biaoqing(newText)
				local newText = del_link(newText)
				--ChatFrame99:AddMessage(newText);
				if PIGA["Chat"]["TiquKey"]["guolvchongfu"] then--过滤非自身重复发言
					local duibiText=del_biaodian(newText)
					for i=#chongfufayanduibi,1,-1 do
						if (GetServerTime()-chongfufayanduibi[i][1])>60 then
							table.remove(chongfufayanduibi,i)
						end
					end
					for i=1,#chongfufayanduibi do
						if chongfufayanduibi[i][2]==duibiText then
							return false
						end
					end
					table.insert(chongfufayanduibi,{GetServerTime(),duibiText})
				end
				--屏蔽黑名单
				if BlackTxt(newText) then
					if PIGA["Chat"]["TiquKey"]["xitongjihuoB"] then
						return false
					end
				else
					local Chatlist_W = QuickChatfun["Keyword"]--提取
					if #Chatlist_W>0 then
						for x=1,#Chatlist_W do
							ChatFrame99.ALLcunzai=true;	
							for xx=1,#Chatlist_W[x] do
								if not newText:match(Chatlist_W[x][xx]) then
									ChatFrame99.ALLcunzai = false
									break
								end
							end
							if ChatFrame99.ALLcunzai then
								ChatFrame99:AddMessage(text, ...);
								break
							end
						end
					end
				end
			end
		end
	end
	return text
end
---
function QuickChatfun.PIGMessage()
	local wanjia, realm = UnitFullName("player")
	local realm=realm or GetRealmName()
	keyzijiname=keyzijiname or wanjia
	if PIGA["Chat"]["ShowZb"] then
		hooksecurefunc("SetItemRef", function(link, text, button, chatFrame)
			if ( strsub(link, 1, 11) == "garrmission" ) then
				local namelink = strsub(link, 13);
				--local name_server, lineID, chatType, chatTarget = strsplit(":", namelink);
				local name_server = strsplit(":", namelink);
				if tocversion<100000 then
					local name,server = strsplit("-",name_server)
					if GetRealmName()==server then
						name_server = name
					end
				end
				if button=="LeftButton" then
					FasongYCqingqiu(name_server)
				else
					C_FriendList.SendWho('n-"'..name_server..'"')
				end
			end
		end)
	end
	--PIGA["xxxxxx"]={}
	for i = 1, NUM_CHAT_WINDOWS do
		if ( i ~= 2 ) then
			local chatID = _G["ChatFrame"..i]
			local msninfo = chatID.AddMessage
			chatID.AddMessage = function(frame, text, ...)
				--table.insert(PIGA["xxxxxx"],text)
				local text=jingjianTXT(text)
				local text=ShowZb(text)
				local text=TiquKey(text,...)--提取
				if text then
					return msninfo(frame, text, ...)
				end
			end
		end
	end
end