local _, addonTable = ...;
local _, _, _, tocversion = GetBuildInfo()
local fmod=math.fmod
local gsub = _G.string.gsub
local Create = addonTable.Create
local PIGLine=Create.PIGLine
local PIGFrame=Create.PIGFrame
local PIGCloseBut = Create.PIGCloseBut
local PIGFontString=Create.PIGFontString
local PIGOptionsList_R=Create.PIGOptionsList_R
--------
local Economy=addonTable.Common.Economy
function Economy.Token()
	local StatsInfo = StatsInfo_UI
	local fujiF,fujiTabBut=PIGOptionsList_R(StatsInfo.F,"货\n币",StatsInfo.butW,"Left")
	---
	local hang_Height,hang_NUM  = 19.4, 11;
	fujiF.Tokens=PIGFrame(fujiF)
	fujiF.Tokens:SetPoint("TOPLEFT",fujiF,"TOPLEFT",2,-2);
	fujiF.Tokens:SetPoint("BOTTOMRIGHT",fujiF,"BOTTOMRIGHT",-4,2);
	fujiF.Tokens.title = PIGFontString(fujiF.Tokens,{"TOPLEFT", fujiF.Tokens, "TOPLEFT", 4, -8},ICON_TAG_RAID_TARGET_STAR3..TOTAL..": ")
	fujiF.Tokens.title:SetTextColor(0, 1, 0, 1);
	fujiF.Tokens.ALLG = PIGFontString(fujiF.Tokens,{"LEFT", fujiF.Tokens.title, "RIGHT", 0, 0},0)
	fujiF.Tokens.ALLG:SetTextColor(1, 1, 1, 1);
	fujiF.Tokens.lineTOP = PIGLine(fujiF.Tokens,"TOP",-30,nil,nil,{0.3,0.3,0.3,0.3})
	local buttons = TokenFrameContainer and TokenFrameContainer.buttons or {}
	local numButtons = #buttons;
	local function gengxin_List(self)
		if not fujiF:IsVisible() then return end
		for id = 1, hang_NUM, 1 do
			_G["PIG_Tokens_"..id]:Hide();
			for but=1,numButtons do
				local paizibut = _G["PIG_Tokens_"..id.."_But"..but]
				paizibut:Hide()
				paizibut.Tex:SetTexCoord(0,1,0,1);
			end
		end
		local cdmulu={};
		local jibihejiV=0
		local PlayerData = PIGA["StatsInfo"]["Players"]
	   	for k,v in pairs(PlayerData) do
	   		local Money  = PIGA["StatsInfo"]["Token"][k]["Money"]
	   		jibihejiV=jibihejiV+Money
	   		local Tokens  = PIGA["StatsInfo"]["Token"][k]["Tokens"]
	   		if Money>0 or #Tokens>0 then
	   			table.insert(cdmulu,{k,v[1],v[2],v[3],v[4],v[5],{Money,Tokens}})
	   		end
	   	end
	   	fujiF.Tokens.ALLG:SetText(GetMoneyString(jibihejiV))
		local ItemsNum = #cdmulu;
		if ItemsNum>0 then
		    FauxScrollFrame_Update(self, ItemsNum, hang_NUM, hang_Height);
		    local offset = FauxScrollFrame_GetOffset(self);
		    for id = 1, hang_NUM do
				local dangqian = id+offset;
				if cdmulu[dangqian] then
					local fujik = _G["PIG_Tokens_"..id]
					fujik:Show();
					if cdmulu[dangqian][2]=="Alliance" then
						fujik.Faction:SetTexCoord(0,0.5,0,1);
					elseif cdmulu[dangqian][2]=="Horde" then
						fujik.Faction:SetTexCoord(0.5,1,0,1);
					end
					fujik.Race:SetAtlas(cdmulu[dangqian][4]);
					local className, classFile, classID = GetClassInfo(cdmulu[dangqian][5])
					fujik.Class:SetTexCoord(unpack(CLASS_ICON_TCOORDS[classFile]));
					fujik.level:SetText(cdmulu[dangqian][6]);
					fujik.name:SetText(cdmulu[dangqian][1]);
					local rPerc, gPerc, bPerc, argbHex = GetClassColor(classFile);
					fujik.name:SetTextColor(rPerc, gPerc, bPerc, 1);
					fujik.del.name=cdmulu[dangqian][1]
					fujik.Money:SetText(floor(cdmulu[dangqian][7][1]*0.0001))
					local paiziD = cdmulu[dangqian][7][2]
					for but=1,#paiziD do
						local paizibut = _G["PIG_Tokens_"..id.."_But"..but]
						paizibut:Show()
						if paiziD[but][1]==136998 or paiziD[but][1]==137000 then
							paizibut.Tex:SetTexCoord(0.1,0.56,0,0.6);
						end
						paizibut.Tex:SetTexture(paiziD[but][1])
						paizibut.num:SetText(paiziD[but][2])
						paizibut:SetScript("OnEnter", function (self)
							GameTooltip:ClearLines();
							GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
							-- GameTooltip:SetCurrencyTokenByID(paiziD[but][3])
							GameTooltip:SetText(paiziD[but][4]);
							GameTooltip:Show();
						end);
						paizibut:SetScript("OnLeave", function ()
							GameTooltip:ClearLines();
							GameTooltip:Hide() 
						end);
					end
				end
			end
		end
	end
	fujiF.Tokens.Scroll = CreateFrame("ScrollFrame",nil,fujiF.Tokens, "FauxScrollFrameTemplate");  
	fujiF.Tokens.Scroll:SetPoint("TOPLEFT",fujiF.Tokens.lineTOP,"BOTTOMLEFT",2,-2);
	fujiF.Tokens.Scroll:SetPoint("BOTTOMRIGHT",fujiF.Tokens,"BOTTOMRIGHT",-20,2);
	fujiF.Tokens.Scroll:SetScript("OnVerticalScroll", function(self, offset)
	    FauxScrollFrame_OnVerticalScroll(self, offset, hang_Height, gengxin_List)
	end)
	for id = 1, hang_NUM, 1 do
		local hang = CreateFrame("Frame", "PIG_Tokens_"..id, fujiF.Tokens);
		hang:SetSize(fujiF.Tokens:GetWidth()-18,hang_Height*2+4);
		if id==1 then
			hang:SetPoint("TOPLEFT", fujiF.Tokens.Scroll, "TOPLEFT", 0, 0);
		else
			hang:SetPoint("TOPLEFT", _G["PIG_Tokens_"..id-1], "BOTTOMLEFT", 0, 0);
		end
		if id~=hang_NUM then
			hang.line = PIGLine(hang,"BOT",0,nil,nil,{0.3,0.3,0.3,0.6})
		end
		hang.Faction = hang:CreateTexture();
		hang.Faction:SetTexture("interface/glues/charactercreate/ui-charactercreate-factions.blp");
		hang.Faction:SetPoint("TOPLEFT", hang, "TOPLEFT", 0,-2);
		hang.Faction:SetSize(hang_Height,hang_Height);
		hang.Race = hang:CreateTexture();
		hang.Race:SetTexture("Interface/Glues/CharacterCreate/CharacterCreateIcons")
		hang.Race:SetPoint("LEFT", hang.Faction, "RIGHT", 1,0);
		hang.Race:SetSize(hang_Height,hang_Height);
		hang.Class = hang:CreateTexture();
		hang.Class:SetTexture("interface/glues/charactercreate/ui-charactercreate-classes.blp")
		hang.Class:SetPoint("LEFT", hang.Race, "RIGHT", 1,0);
		hang.Class:SetSize(hang_Height,hang_Height);
		hang.level = PIGFontString(hang,{"LEFT", hang.Class, "RIGHT", 2, 0},1)
		hang.level:SetTextColor(1,0.843,0, 1);
		hang.name = PIGFontString(hang,{"TOPLEFT", hang.Faction, "BOTTOMLEFT", 0, -2})
		hang.MoneyTex = hang:CreateTexture();
		hang.MoneyTex:SetTexture(237618)
		hang.MoneyTex:SetPoint("LEFT", hang.Class, "RIGHT", 100,0);
		hang.MoneyTex:SetSize(hang_Height-4,hang_Height-4);
		hang.Money = PIGFontString(hang,{"RIGHT", hang.MoneyTex, "LEFT", 0, 0},0)
		hang.Money:SetTextColor(1, 1, 1, 1);
		hang.Tokens = CreateFrame("Frame", nil, hang);
		hang.Tokens:SetPoint("LEFT", hang.Class, "RIGHT", 180,0);
		hang.Tokens:SetSize(hang_Height,hang_Height);
		for but=1,numButtons do
			local TokenBut = CreateFrame("Button","PIG_Tokens_"..id.."_But"..but,hang.Tokens);
			TokenBut:SetSize(hang_Height,hang_Height);
			if but==1 then
				TokenBut:SetPoint("LEFT", hang.Tokens, "LEFT", 0,0);
			elseif but==10 then
				TokenBut:SetPoint("TOPLEFT", _G["PIG_Tokens_"..id.."_But1"], "BOTTOMLEFT", 0,-2);
			else
				TokenBut:SetPoint("LEFT", _G["PIG_Tokens_"..id.."_But"..(but-1)], "RIGHT", 50,0);
			end
			TokenBut.Tex = TokenBut:CreateTexture();
			TokenBut.Tex:SetPoint("CENTER",0,0);
			TokenBut.Tex:SetSize(hang_Height,hang_Height);
			TokenBut.num = PIGFontString(TokenBut,{"RIGHT", TokenBut, "LEFT", -2, 0},0)
			TokenBut.num:SetTextColor(1, 1, 1, 1);
		end
		hang.del=PIGCloseBut(hang,{"LEFT", hang.level, "RIGHT", 0,0},{hang_Height,hang_Height})
		hang.del:SetScript("OnClick", function (self)
			local wanjianame = self.name
			PIGA["StatsInfo"]["Players"][wanjianame]=nil
			PIGA["StatsInfo"]["Token"][wanjianame]=nil
			gengxin_List(fujiF.Tokens.Scroll);
		end);
	end
	fujiF:HookScript("OnShow", function(self)
		gengxin_List(self.Tokens.Scroll);
	end)
	---
	local function PIGGetMoney()
		PIGA["StatsInfo"]["Token"][StatsInfo.allname]["Money"]=GetMoney()
	end
	local function GetTokenInfo()
		local TokensInfo = {}
		for index=1,numButtons do
			local name, isHeader, isExpanded, isUnused, isWatched, count, icon, maxQuantity, maxEarnable, quantityEarned, isTradeable, itemID = GetCurrencyListInfo(index);
			if name and name ~= "" then
				if not isHeader and not isUnused then
					table.insert(TokensInfo,{icon,count,itemID,C_CurrencyInfo.GetCurrencyListLink(index)})
					--print(name, isHeader, isExpanded, isUnused, isWatched, count, icon, maxQuantity, maxEarnable, quantityEarned, isTradeable, itemID)
				end
			end
		end
		PIGA["StatsInfo"]["Token"][StatsInfo.allname]["Tokens"]=TokensInfo
	end
	local function jiazaiTokenInfo()
		PIGA["StatsInfo"]["Token"][StatsInfo.allname]=PIGA["StatsInfo"]["Token"][StatsInfo.allname] or {}
		C_Timer.After(1,PIGGetMoney)
		C_Timer.After(1,GetTokenInfo)
		fujiF:RegisterEvent("PLAYER_MONEY")
		fujiF:RegisterEvent("PLAYER_MONEY")
	end
	fujiF:RegisterEvent("PLAYER_ENTERING_WORLD")       
	fujiF:SetScript("OnEvent", function(self,event,arg1)
		if event=="PLAYER_ENTERING_WORLD" then
			C_Timer.After(1,jiazaiTokenInfo)
		end
		if event=="PLAYER_MONEY" then
			PIGGetMoney()
		end
	end)
end
