local _, addonTable = ...;
local _, _, _, tocversion = GetBuildInfo()
local lower=string.lower
--local upper=string.upper
--
local Create = addonTable.Create
local PIGFrame=Create.PIGFrame
local PIGLine=Create.PIGLine
local PIGModbutton=Create.PIGModbutton
local PIGFontString=Create.PIGFontString
local PIGCloseBut=Create.PIGCloseBut
local PIGOptionsList_RF=Create.PIGOptionsList_RF
--
local Economy=addonTable.Common.Economy
function Economy.disp_time(time)
	local days = floor(time/86400)
	local hours = floor(mod(time, 86400)/3600)
	local minutes = math.ceil(mod(time,3600)/60)
	if time>86400 then
		return format("|c00FF0000%d天%d时%d分|r",days,hours,minutes)
	elseif time<86400 and time>3600 then
		return format("|c00FFA500%d时%d分|r",hours,minutes)
	elseif time<3600 and time>60 then
		return format("|c00FFFF40%d分|r",minutes)
	end
end
--=================================
local GnName,GnUI,GnIcon,FrameLevel = unpack(Economy.StatsInfo)
local Width,Height,biaotiH  = 860, 530, 21;
--
local genders = {[2]="male", [3]="female"}
local function Get_renwuInfo(infoUI)
    local wanjia, realm = UnitFullName("player")
	local realm=realm or GetRealmName()
	infoUI.allname = wanjia.."-"..realm
	local englishFaction= UnitFactionGroup("player")--阵营"Alliance"/"Horde"
	--infoUI.englishFaction = englishFaction
	local _, raceFile, raceID = UnitRace("player")
	--infoUI.raceID = raceID
	local _, classId = UnitClassBase("player")
	--infoUI.classId = classId
	local level = UnitLevel("player")
	--infoUI.level = level
	local gender = UnitSex("player")
	if raceFile=="Scourge" then raceFile="undead" end
	local race_icon = lower("raceicon-"..raceFile.."-"..genders[gender])
	PIGA["StatsInfo"]["Players"][infoUI.allname]={englishFaction,raceID,race_icon,classId,level}
end
--===========================
Economy.fun.StatsInfo = function()
	if not PIGA["StatsInfo"]["Open"] then return end
	if _G[GnUI] then return end
	local ModBut = PIGModbutton(GnName,GnIcon,GnUI,FrameLevel)
	local StatsInfo=PIGFrame(UIParent,{"CENTER",UIParent,"CENTER",0,60},{Width,Height},GnUI,true)
	StatsInfo:PIGSetBackdrop()
	StatsInfo:PIGClose()
	StatsInfo:PIGSetMovable()
	StatsInfo.butW=50
	StatsInfo.title = PIGFontString(StatsInfo,{"TOP", StatsInfo, "TOP", 0, -3},GnName)
	PIGLine(StatsInfo,"TOP",-biaotiH)
	StatsInfo.F=PIGOptionsList_RF(StatsInfo,biaotiH,"Left")
	Economy.FBCD()
	Economy.SkillCD()
	Economy.Token()
	Economy.Item()
	Get_renwuInfo(StatsInfo)
    StatsInfo:RegisterEvent("PLAYER_ENTERING_WORLD")
    StatsInfo:SetScript("OnEvent", function(self, event, arg1)
    	Get_renwuInfo(self)
    end)
end
