local _, addonTable = ...;
local _, _, _, tocversion = GetBuildInfo()
--------
local Create = addonTable.Create
local PIGFrame=Create.PIGFrame
local PIGQuickBut=Create.PIGQuickBut
local PIGCheckbutton=Create.PIGCheckbutton
local PIGCheckbutton_R=Create.PIGCheckbutton_R
local PIGFontString=Create.PIGFontString
--
local GetContainerNumFreeSlots = C_Container.GetContainerNumFreeSlots
local GetContainerNumSlots = C_Container.GetContainerNumSlots
local GetContainerItemID = C_Container.GetContainerItemID
local PickupContainerItem =C_Container.PickupContainerItem
--=======================================
local zhuangbeixilieID={
	{1,"Head",true},
	{2,"Neck",false},
	{3,"Shoulder",true},
	{4,"Shirt",false},
	{5,"Chest",true},
	{6,"Waist",true},
	{7,"Legs",true},
	{8,"Feet",true},
	{9,"Wrist",true},
	{10,"Hands",true},
	{11,"Finger0",false},
	{12,"Finger1",false},
	{13,"Trinket0",false},
	{14,"Trinket1",false},
	{15,"Back",false},
	{16,"MainHand",true},
	{17,"SecondaryHand",true},
	{18,"Ranged",true},
	{19,"Tabard",false},
}
local ActionBarfun=addonTable.ActionBarfun
local QuickButF=ActionBarfun.QuickButF
local AutoEquip_tooltip = {
	"添加<装备管理>到功能动作条",
	"启动装备管理,在功能动作条显示装备管理按钮。|r"
}
QuickButF.ModF.AutoEquip=PIGCheckbutton_R(QuickButF.ModF,AutoEquip_tooltip,true)
QuickButF.ModF.AutoEquip:SetScript("OnClick", function (self)
	if self:GetChecked() then
		PIGA["QuickBut"]["AutoEquip"]=true;
		QuickButUI.ButList[6]()
	else
		PIGA["QuickBut"]["AutoEquip"]=false;
		Pig_Options_RLtishi_UI:Show()
	end
end)
--
QuickButF.ModF:HookScript("OnShow", function(self)
	self.AutoEquip:SetChecked(PIGA["QuickBut"]["AutoEquip"])
end)
QuickButUI.ButList[6]=function()
	if not PIGA["QuickBut"]["Open"] or not PIGA["QuickBut"]["AutoEquip"] then return end
	local GnUI = "QkBut_AutoEquip"
	if _G[GnUI] then return end
	local FrameOnUpdate = CreateFrame("Frame");
	FrameOnUpdate:Hide()
	local Icon=133122
	local Tooltip = "左击-|cff00FFFF展开切换按钮|r\n右击-|cff00FFFF卸下身上有耐久装备|r"
	local AutoEquip=PIGQuickBut(GnUI,Tooltip,Icon,nil,nil,"SecureActionButtonTemplate")
	-- AutoEquip.BGtex = AutoEquip:CreateTexture(nil, "BACKGROUND", nil, -1);
	-- AutoEquip.BGtex:SetTexture("interface/buttons/ui-emptyslot-white.blp");
	-- AutoEquip.BGtex:SetPoint("TOPLEFT", -10, 10);
	-- AutoEquip.BGtex:SetPoint("BOTTOMRIGHT", 10, -10);
	-- AutoEquip.iconx = AutoEquip:CreateTexture(nil, "ARTWORK");
	-- AutoEquip.iconx:SetTexture(514608);
	-- AutoEquip.iconx:SetTexCoord(0.04,0.50,0.48,0.60);
	-- AutoEquip.iconx:SetPoint("TOPLEFT", 0, 0);
	-- AutoEquip.iconx:SetPoint("BOTTOMRIGHT", 0, 0);
	--
	local NumTexCoord = {
		{0.326,0.43,0,0.32},
		{0.546,0.694,0,0.32},
		{0.80,0.95,0,0.32},
		{0.04,0.21,0.33,0.66},
		{0.3,0.45,0.33,0.66},
		{0.546,0.71,0.33,0.66},
	}
	local butW = QuickButUI.nr:GetHeight()
	local anniushu=	MAX_EQUIPMENT_SETS_PER_PLAYER
	if tocversion<30000 then
		anniushu=6
	end
	local function gengxin_List()
		local equipmentSetIDs = C_EquipmentSet.GetEquipmentSetIDs()
		for but=1,anniushu do
			local fujikj = _G["AutoEquip_but"..but]
			if equipmentSetIDs[but] then
				fujikj.id=equipmentSetIDs[but]
				local name, iconFileID, setID, isEquipped, numItems, numEquipped, numInInventory, numLost, numIgnored = C_EquipmentSet.GetEquipmentSetInfo(equipmentSetIDs[but])
				fujikj.Tex:SetTexture(iconFileID);
				fujikj.name:SetText(name);
			else
				fujikj.id=nil
				fujikj.Tex:SetTexture(nil);
				fujikj.name:SetText(nil);
			end
		end
	end
	local AutoEquipList = PIGFrame(AutoEquip,{"BOTTOM",AutoEquip,"TOP",0,0},{butW, (butW+6)*anniushu},"AutoEquipList_UI",true)
	for i=1,anniushu do
		local AutoEquip_but = CreateFrame("Button", "AutoEquip_but"..i, AutoEquipList,nil,i)
		AutoEquip_but:SetHighlightTexture(130718);
		AutoEquip_but:SetSize(butW, butW)

		AutoEquip_but.BGtex = AutoEquip_but:CreateTexture(nil, "BACKGROUND", nil, -1);
		AutoEquip_but.BGtex:SetTexture("Interface/Buttons/UI-Quickslot");
		AutoEquip_but.BGtex:SetAlpha(0.4);
		AutoEquip_but.BGtex:SetSize(butW+18, butW+18)
		AutoEquip_but.BGtex:SetPoint("CENTER", 0, 0);

		AutoEquip_but.Tex = AutoEquip_but:CreateTexture(nil, "BORDER");
		AutoEquip_but.Tex:SetPoint("TOPLEFT", 0, 0);
		AutoEquip_but.Tex:SetPoint("BOTTOMRIGHT", 0, 0);
		if tocversion<30000 then
			AutoEquip_but.Tex:SetTexture("interface/timer/bigtimernumbers.blp");
			AutoEquip_but.Tex:SetTexCoord(NumTexCoord[i][1],NumTexCoord[i][2],NumTexCoord[i][3],NumTexCoord[i][4]);
		end

		AutoEquip_but.name = PIGFontString(AutoEquip_but,{"BOTTOM", AutoEquip_but, "BOTTOM", 0, 0},nil,"OUTLINE",12)
		AutoEquip_but.name:SetTextColor(1, 1, 1, 1)
		AutoEquip_but:RegisterForClicks("AnyUp");
		AutoEquip_but.Down = AutoEquip_but:CreateTexture(nil, "OVERLAY");
		AutoEquip_but.Down:SetTexture(130839);
		AutoEquip_but.Down:SetAllPoints(AutoEquip_but)
		AutoEquip_but.Down:Hide();
		AutoEquip_but:SetScript("OnMouseDown", function (self)
			self.Down:Show();
			GameTooltip:ClearLines();
			GameTooltip:Hide() 
		end);
		AutoEquip_but:SetScript("OnMouseUp", function (self)
			self.Down:Hide();
		end);
		AutoEquip_but:SetScript("OnEnter", function (self)
			GameTooltip:ClearLines();
			GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT",0,0);
			if tocversion<30000 then
				GameTooltip:AddLine("左击-|cff00FFFF切换配装|r\n右击-|cff00FFFF保存当前配装|r")
			else
				local erqid = self.id
				if erqid and erqid>=0 then
					GameTooltip:AddLine("左击-|cff00FFFF切换配装|r\n右击-|cff00FFFF保存当前配装|r\nShift+左键-|cff00FFFF编辑|r")
				else
					GameTooltip:AddLine("|cffFFFF00点击新建配装方案|r")
				end
			end
			GameTooltip:Show();
		end);
		AutoEquip_but:SetScript("OnLeave", function ()
			GameTooltip:ClearLines();
			GameTooltip:Hide() 
		end);
		AutoEquip_but:SetScript("OnClick", function(self,button)
			PlaySound(SOUNDKIT.IG_CHARACTER_INFO_OPEN);
			if tocversion<30000 then
				if button=="LeftButton" then
					if InCombatLockdown() then return end
					local wupinshujuinfo =PIGA_Per['QuickBut']['AutoEquipList'][i]
					if wupinshujuinfo then
						FrameOnUpdate.hejilist={}
						for gg=1,#wupinshujuinfo do
							if wupinshujuinfo[gg][2] then
								EquipItemByName(wupinshujuinfo[gg][2], wupinshujuinfo[gg][1])
							else
								local itemLink = GetInventoryItemLink("player", zhuangbeixilieID[gg][1])
								if itemLink then
									if wupinshujuinfo[gg][1]==17 then
										if wupinshujuinfo[gg-1][2] then
											local fffffID =C_Item.GetItemInventoryTypeByID(wupinshujuinfo[gg-1][2])
											if fffffID~=17 then
												table.insert(FrameOnUpdate.hejilist,zhuangbeixilieID[gg][1])
											end
										end
									else
										table.insert(FrameOnUpdate.hejilist,zhuangbeixilieID[gg][1])
									end	
								end
							end
						end
						if #FrameOnUpdate.hejilist>0 then
							FrameOnUpdate.konggekaishi=0
							FrameOnUpdate.konggelist={}
							for bagID=0,4 do
								local numberOfFreeSlots, bagType = GetContainerNumFreeSlots(bagID)
								if numberOfFreeSlots>0 and bagType==0 then
									for ff=1,GetContainerNumSlots(bagID) do
										if GetContainerItemID(bagID, ff) then
										else
											table.insert(FrameOnUpdate.konggelist,{bagID,ff})
											FrameOnUpdate.konggekaishi=FrameOnUpdate.konggekaishi+1
											if FrameOnUpdate.konggekaishi==#FrameOnUpdate.hejilist then
												break
											end
										end
									end
								end
								if FrameOnUpdate.konggekaishi==#FrameOnUpdate.hejilist then
									break
								end
							end
				
							for inv = 1, #FrameOnUpdate.konggelist do
								local isLocked2 = IsInventoryItemLocked(FrameOnUpdate.hejilist[inv])
								if not isLocked2 then
									PickupInventoryItem(FrameOnUpdate.hejilist[inv])
									PickupContainerItem(FrameOnUpdate.konggelist[inv][1], FrameOnUpdate.konggelist[inv][2])
								end
							end
							if #FrameOnUpdate.konggelist<#FrameOnUpdate.hejilist then
								PIGinfotip:TryDisplayMessage("更换"..i.."号配装失败(背包剩余空间不足)")
								return
							end
						end
						PIGinfotip:TryDisplayMessage("更换"..i.."号配装成功")
					else
						PIGinfotip:TryDisplayMessage(i.."号尚未保存配装",1,0,0)
					end
				else
					local wupinshujuinfo = {}
					for inv = 1, #zhuangbeixilieID do
						local itemLink = GetInventoryItemLink("player", zhuangbeixilieID[inv][1])
						table.insert(wupinshujuinfo, {zhuangbeixilieID[inv][1],itemLink});
					end
					PIGA_Per['QuickBut']['AutoEquipList'][i] = wupinshujuinfo
					PIGinfotip:TryDisplayMessage("当前装备已保存到"..i.."号配装")
				end
			else
				local erqid = self.id
				--local erqid = C_EquipmentSet.GetEquipmentSetID(name)
				if erqid and erqid>=0 then
					--local name, iconFileID, setID, isEquipped, numItems, numEquipped, numInInventory, numLost, numIgnored
					local name = C_EquipmentSet.GetEquipmentSetInfo(erqid)
					if button=="LeftButton" then
						if IsShiftKeyDown() then
							GearManagerDialog_Update();	
							local bianjibutid
							for ixx=1,anniushu do
								local xxfuji = _G["GearSetButton"..ixx]
								if xxfuji.id==erqid then
									bianjibutid=ixx
									break
								end
							end
							if bianjibutid and bianjibutid>=0 then
								ShowUIPanel(CharacterFrame);
								local xxfuji = _G["GearSetButton"..bianjibutid]
								GearManagerDialog.selectedSetName = xxfuji.name;
								GearManagerDialog.selectedSetIcon = xxfuji.icon:GetTexture();
								GearManagerDialog:Show();
								GearManagerDialogSaveSet_OnClick()
							end
						elseif IsControlKeyDown() then
							-- C_EquipmentSet.DeleteEquipmentSet(erqid)
							-- PIGinfotip:TryDisplayMessage("已删除<"..name..">配装")
							gengxin_List()
						else
							C_EquipmentSet.UseEquipmentSet(erqid)
							PIGinfotip:TryDisplayMessage("更换<"..name..">配装成功")
						end
					else
						--C_EquipmentSet.UnassignEquipmentSetSpec(i-1)
						C_EquipmentSet.SaveEquipmentSet(erqid)
						PIGinfotip:TryDisplayMessage("当前装备已保存到<"..name..">配装")
					end
				else
					if InCombatLockdown() then
						PIGinfotip:TryDisplayMessage("战斗中无法保存")
					else
						ShowUIPanel(CharacterFrame);
						GearManagerDialog:Show();
						GearManagerDialogSaveSet_OnClick()
					end
				end
			end
			AutoEquipList:Hide()
		end)
	end
	--
	local function SetPoints(self)
		local WowHeight=GetScreenHeight();
		local offset1 = self:GetBottom();
		AutoEquipList:ClearAllPoints();
		if offset1>(WowHeight*0.5) then
			for i=1,anniushu do
				local fujikj = _G["AutoEquip_but"..i]
				fujikj:ClearAllPoints();
				if i==1 then
					fujikj:SetPoint("TOP",AutoEquipList,"TOP",0,0);
				else
					local fujikj_1 = _G["AutoEquip_but"..(i-1)]
					fujikj:SetPoint("TOP",fujikj_1,"BOTTOM",0,-6);
				end
			end
			AutoEquipList:SetPoint("TOP",self,"BOTTOM",0,-6);
		else
			for i=1,anniushu do
				local fujikj = _G["AutoEquip_but"..i]
				fujikj:ClearAllPoints();
				if i==1 then
					fujikj:SetPoint("BOTTOM",AutoEquipList,"BOTTOM",0,0);
				else
					local fujikj_1 = _G["AutoEquip_but"..(i-1)]
					fujikj:SetPoint("BOTTOM",fujikj_1,"TOP",0,6);
				end
			end
			AutoEquipList:SetPoint("BOTTOM",self,"TOP",0,6);
		end
		AutoEquipList:Show()
	end
	local xiezhuangbei = [=[/run PickupInventoryItem(16) C_Container.PickupContainerItem(0, 1)]=]
	AutoEquip:SetAttribute("type", "macro")
	AutoEquip:SetAttribute("macrotext", xiezhuangbei)
	AutoEquip:SetScript("OnClick", function(self,button)
		if button=="LeftButton" then
			if tocversion<30000 then
				if AutoEquipList:IsShown() then
					AutoEquipList:Hide()
				else
					SetPoints(self)
				end
			else
				local kaiqiq=GetCVar("equipmentManager")
				if kaiqiq=="0" then
					SetCVar("equipmentManager","1")
					PIGinfotip:TryDisplayMessage("已打开装备管理功能")
				end
				if AutoEquipList:IsShown() then
					AutoEquipList:Hide()
				else
					SetPoints(self)
					gengxin_List()
				end
			end
		else
			if not InCombatLockdown() then
				FrameOnUpdate.hejilist={}
				for inv = 1, #zhuangbeixilieID do
					if zhuangbeixilieID[inv][3] then
						if GetInventoryItemID("player",zhuangbeixilieID[inv][1]) then
							table.insert(FrameOnUpdate.hejilist,zhuangbeixilieID[inv][1])
						end
					end
				end
				FrameOnUpdate.konggekaishi=0
				FrameOnUpdate.konggelist={}
				for bagID=0,4 do
					local numberOfFreeSlots, bagType = GetContainerNumFreeSlots(bagID)
					if numberOfFreeSlots>0 and bagType==0 then
						for ff=1,GetContainerNumSlots(bagID) do
							if GetContainerItemID(bagID, ff) then
							else
								table.insert(FrameOnUpdate.konggelist,{bagID,ff})
								FrameOnUpdate.konggekaishi=FrameOnUpdate.konggekaishi+1
								if FrameOnUpdate.konggekaishi==#FrameOnUpdate.hejilist then
									break
								end
							end
						end
					end
					if FrameOnUpdate.konggekaishi==#FrameOnUpdate.hejilist then
						break
					end
				end
				if #FrameOnUpdate.hejilist>0 then
					if #FrameOnUpdate.konggelist<#FrameOnUpdate.hejilist then
						PIGinfotip:TryDisplayMessage("背包剩余空间不足，无法全部卸下")
					end
					for inv = 1, #FrameOnUpdate.konggelist do
						local isLocked2 = IsInventoryItemLocked(FrameOnUpdate.hejilist[inv])
						if not isLocked2 then
							PickupInventoryItem(FrameOnUpdate.hejilist[inv])
							PickupContainerItem(FrameOnUpdate.konggelist[inv][1], FrameOnUpdate.konggelist[inv][2])
						end
					end
					PIGinfotip:TryDisplayMessage("已卸下全部有耐久装备")
				end
			end
			AutoEquipList:Hide()
		end
	end);
end